#include "BinMemoryInputStream.hpp"

void BinMemoryInputStream::initialize(void *data_parm, int length_parm) {
	data = new char[length = length_parm];
	memcpy(data, data_parm, length_parm);
	pointer = 0;
}

BinMemoryInputStream::BinMemoryInputStream(char *data) { initialize( data, strlen(data) ); }
BinMemoryInputStream::BinMemoryInputStream(void *data, int length) { initialize(data, length); }
BinMemoryInputStream::~BinMemoryInputStream() { delete[] data; }

unsigned int BinMemoryInputStream::curPos() const { return pointer; }
unsigned int BinMemoryInputStream::readBytes(XMLByte* const toFill, const unsigned int maxToRead) {

	int bytesLeft = length - pointer;
	int amount = maxToRead > bytesLeft ? bytesLeft : maxToRead;

	memcpy(toFill, data + pointer, amount);
	pointer += amount;

	return amount;
}
