#include "FileInputSource.hpp"

char *FileInputSource::FileInputSourceToSystemId(const FileInputSource *ptr) {
	static char string[128];
	sprintf(string, "FileInputSource(%#0*x)", 2*sizeof(int) + 2, ptr);
	return string;
}


FileInputSource::FileInputSource(const char *filename) :
		InputSource( FileInputSourceToSystemId(this) ) {
	descriptor = open(filename, O_RDONLY);
}

FileInputSource::FileInputSource(const char *filename, const char *const systemId) :
		InputSource(systemId) {
	descriptor = open(filename, O_RDONLY);
}

FileInputSource::FileInputSource(const char *filename, const char *const systemId, const char *const publicId) :
		InputSource(systemId, publicId) {
	descriptor = open(filename, O_RDONLY);
}

FileInputSource::FileInputSource(const char *filename, const XMLCh *const systemId) :
		InputSource(systemId) {
	descriptor = open(filename, O_RDONLY);
}

FileInputSource::FileInputSource(const char *filename, const XMLCh *const systemId, const XMLCh *const publicId) :
		InputSource(systemId, publicId) {
	descriptor = open(filename, O_RDONLY);
}


FileInputSource::FileInputSource(int descriptor_parm) :
		InputSource( FileInputSourceToSystemId(this) ) {
	descriptor = dup(descriptor_parm);
}

FileInputSource::FileInputSource(int descriptor_parm, const char *const systemId) :
		InputSource(systemId) {
	descriptor = dup(descriptor_parm);
}

FileInputSource::FileInputSource(int descriptor_parm, const char *const systemId, const char *const publicId) :
		InputSource(systemId, publicId) {
	descriptor = dup(descriptor_parm);
}

FileInputSource::FileInputSource(int descriptor_parm, const XMLCh *const systemId) :
		InputSource(systemId) {
	descriptor = dup(descriptor_parm);
}

FileInputSource::FileInputSource(int descriptor_parm, const XMLCh *const systemId, const XMLCh *const publicId) :
		InputSource(systemId, publicId) {
	descriptor = dup(descriptor_parm);
}


FileInputSource::~FileInputSource() {
	if (descriptor != -1)	close(descriptor);
}


BinInputStream *FileInputSource::makeStream() const {
	return descriptor == -1 ? 0 : new BinFile2InputStream(descriptor);
}

