#include "MemoryInputSource.hpp"


char *MemoryInputSource::MemoryInputSourceToSystemId(const MemoryInputSource *ptr) {
	static char string[128];
	sprintf(string, "MemoryInputSource(%#0*x)", 2*sizeof(int) + 2, ptr);
	return string;
}



void MemoryInputSource::initialize(const char *string_parm, int strlen_parm) {
	string = new char[length = strlen_parm];
	memcpy(string, string_parm, strlen_parm);
}

MemoryInputSource::MemoryInputSource(const char *string_parm) :
	InputSource( MemoryInputSourceToSystemId(this) ) { initialize( string_parm, strlen(string_parm) ); }

MemoryInputSource::MemoryInputSource(const char *string_parm, const char *const systemId) :
	InputSource(systemId) { initialize( string_parm, strlen(string_parm) ); }

MemoryInputSource::MemoryInputSource(const char *string_parm, const char *const systemId, const char *const publicId) :
	InputSource(systemId, publicId) { initialize( string_parm, strlen(string_parm) ); }

MemoryInputSource::MemoryInputSource(const char *string_parm, const XMLCh *const systemId) :
	InputSource(systemId) { initialize( string_parm, strlen(string_parm) ); }

MemoryInputSource::MemoryInputSource(const char *string_parm, const XMLCh *const systemId, const XMLCh *const publicId) :
	InputSource(systemId, publicId) { initialize( string_parm, strlen(string_parm) ); }


MemoryInputSource::MemoryInputSource(const char *string_parm, int strlen_parm) :
	InputSource( MemoryInputSourceToSystemId(this) ) { initialize(string_parm, strlen_parm); }

MemoryInputSource::MemoryInputSource(const char *string_parm, int strlen_parm, const char *const systemId) :
	InputSource(systemId) { initialize(string_parm, strlen_parm); }

MemoryInputSource::MemoryInputSource(const char *string_parm, int strlen_parm, const char *const systemId, const char *const publicId) :
	InputSource(systemId, publicId) { initialize(string_parm, strlen_parm); }

MemoryInputSource::MemoryInputSource(const char *string_parm, int strlen_parm, const XMLCh *const systemId) :
	InputSource(systemId) { initialize(string_parm, strlen_parm); }

MemoryInputSource::MemoryInputSource(const char *string_parm, int strlen_parm, const XMLCh *const systemId, const XMLCh *const publicId) :
	InputSource(systemId, publicId) { initialize(string_parm, strlen_parm); }


MemoryInputSource::~MemoryInputSource() { delete[] string; }

BinInputStream *MemoryInputSource::makeStream() const {
	return new BinMemoryInputStream(string, length);
}
