#if !defined(BINMEMORYINPUTSTREAM_HPP)
#define BINMEMORYINPUTSTREAM_HPP

#include <util/BinInputStream.hpp>

class XMLUTIL_EXPORT BinMemoryInputStream : public BinInputStream {

private:
	char *data;
	int length;
	int pointer;


	void initialize(void *data, int length);

public :
    // -----------------------------------------------------------------------
    //  Virtual destructor for derived classes
    // -----------------------------------------------------------------------
    BinMemoryInputStream(char *data);
    BinMemoryInputStream(void *data, int length);
    virtual ~BinMemoryInputStream();


    // -----------------------------------------------------------------------
    //  The virtual input stream interface
    // -----------------------------------------------------------------------
    virtual unsigned int curPos() const;

    virtual unsigned int readBytes(XMLByte* const toFill, const unsigned int maxToRead);
};

#endif
