#if !defined(FILEINPUTSOURCE_HPP)
#define FILEINPUTSOURCE_HPP

#include <sax/InputSource.hpp>
#include "BinFile2InputStream.hpp"
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>


class XMLPARSER_EXPORT FileInputSource : public InputSource {

private:

	int descriptor;

        static char *FileInputSourceToSystemId(const FileInputSource *ptr);

public:

    // -----------------------------------------------------------------------
    //  Constructors and Destructor
    // -----------------------------------------------------------------------
    FileInputSource(const char *filename);
    FileInputSource(const char *filename, const char *const systemId);
    FileInputSource(const char *filename, const char *const systemId, const char *const publicId);
    FileInputSource(const char *filename, const XMLCh *const systemId);
    FileInputSource(const char *filename, const XMLCh *const systemId, const XMLCh *const publicId);

    FileInputSource(int descriptor_parm);
    FileInputSource(int descriptor_parm, const char *const systemId);
    FileInputSource(int descriptor_parm, const char *const systemId, const char *const publicId);
    FileInputSource(int descriptor_parm, const XMLCh *const systemId);
    FileInputSource(int descriptor_parm, const XMLCh *const systemId, const XMLCh *const publicId);

    virtual ~FileInputSource();

    BinInputStream *makeStream() const;

};


#endif
