#if !defined(MEMORYINPUTSOURCE_HPP)
#define MEMORYINPUTSOURCE_HPP

#include <sax/InputSource.hpp>
#include "BinMemoryInputStream.hpp"
#include <stdio.h>
#include <string.h>


class XMLPARSER_EXPORT MemoryInputSource : public InputSource {

private:

	char *string;
	int length;

	static char *MemoryInputSourceToSystemId(const MemoryInputSource *ptr);

	void initialize(const char *string_parm, int strlen_parm);


public:

    // -----------------------------------------------------------------------
    //  Constructors and Destructor
    // -----------------------------------------------------------------------
    MemoryInputSource(const char *string_parm);
    MemoryInputSource(const char *string_parm, const char *const systemId);
    MemoryInputSource(const char *string_parm, const char *const systemId, const char *const publicId);
    MemoryInputSource(const char *string_parm, const XMLCh *const systemId);
    MemoryInputSource(const char *string_parm, const XMLCh *const systemId, const XMLCh *const publicId);

    MemoryInputSource(const char *string_parm, int strlen_parm);
    MemoryInputSource(const char *string_parm, int strlen_parm, const char *const systemId);
    MemoryInputSource(const char *string_parm, int strlen_parm, const char *const systemId, const char *const publicId);
    MemoryInputSource(const char *string_parm, int strlen_parm, const XMLCh *const systemId);
    MemoryInputSource(const char *string_parm, int strlen_parm, const XMLCh *const systemId, const XMLCh *const publicId);

    virtual ~MemoryInputSource();

    BinInputStream *makeStream() const;

};


#endif
