
#
# THE @#^%@#$ Test::Harness SETS ALL SORTS OF ANAL-RETENTIVE FLAGS THAT MAKE IT IMPOSSIBLE
# FOR THE TESTS TO PASS BECAUSE SWIG-GENERATED Xerces.pm MODULE ALWAYS HAS ERROR
# "Use of uninitialized value during global destruction."
# THUS, I HAD TO WORK AROUND IT.
#
open TESTSCRIPT, ">testscript.pl";
print TESTSCRIPT <<\TERMINUS;
use Xerces;

sub warning;
sub error;
sub fatal_error;

sub get_worker;

$| = 1;

# PRINT HOW MANY TEST THERE ARE
print "1..1\n";

open PERSONAL, "personal.xml";
$/ = undef;
my $document = <PERSONAL>;
close PERSONAL;

my $dom = new DOMParser;

$error_handler = new perlErrorHandler;
$error_handler->setWarningFunction(\&warning);
$error_handler->setErrorFunction(\&error);
$error_handler->setFatalErrorFunction(\&fatal_error);
$dom->setErrorHandler($error_handler);
$dom->parse( new LocalFileInputSource('personal.xml') );


my($doc, $top, $person, $name, $family, $given, $email, $link, $text, $comment);

$doc = DOM_Document::createDocument;
  $xmldecl = $doc->createXMLDecl('1.0', 'iso-8859-1', 'no');
$doc->appendChild($xmldecl);
$doc->appendChild( $doc->importNode($dom->getDocument->getDoctype, 1) );
  $comment = $doc->createComment(' @version: ');
$doc->appendChild($comment);
  $top = $doc->createElement('personnel');
    $text = $doc->createTextNode("\n\n  ");
  $top->appendChild($text);
    $person = $doc->createElement('person');
    $person->setAttribute('id','Big.Boss');
      $text = $doc->createTextNode("\n    ");
    $person->appendChild($text);
      $name = $doc->createElement('name');
        $family = $doc->createElement('family');
          $text = $doc->createTextNode('Boss');
        $family->appendChild($text);
      $name->appendChild($family);
        $text = $doc->createTextNode(' ');
      $name->appendChild($text);
        $given = $doc->createElement('given');
          $text = $doc->createTextNode('Big');
        $given->appendChild($text);
      $name->appendChild($given);
    $person->appendChild($name);
      $text = $doc->createTextNode("\n    ");
    $person->appendChild($text);
      $email = $doc->createElement('email');
        $text = $doc->createTextNode('chief@foo.com');
      $email->appendChild($text);
    $person->appendChild($email);
      $text = $doc->createTextNode("\n    ");
    $person->appendChild($text);
      $link = $doc->createElement('link');
      $link->setAttribute('subordinates','one.worker two.worker three.worker four.worker five.worker');
    $person->appendChild($link);
      $text = $doc->createTextNode("\n  ");
    $person->appendChild($text);
  $top->appendChild($person);

  for $first_name ( qw(one two three four five) ) {
      $text = $doc->createTextNode("\n\n  ");
    $top->appendChild($text);
    $top->appendChild( get_worker($doc, $first_name) );
  }

    $text = $doc->createTextNode("\n\n");
  $top->appendChild($text);
$doc->appendChild($top);

my $serialize = $doc->serialize;

print "not " if $serialize ne $document;
print "ok\n";

exit 0;

sub get_worker {
  my($doc, $first_name) = @_;

  my($person, $name, $family, $given, $email, $link, $text);

  $person = $doc->createElement('person');
    $text = $doc->createTextNode("\n    ");
  $person->appendChild($text);
  $person->setAttribute('id',"$first_name.worker");
    $name = $doc->createElement('name');
      $family = $doc->createElement('family');
        $text = $doc->createTextNode('Worker');
      $family->appendChild($text);
    $name->appendChild($family);
      $text = $doc->createTextNode(' ');
    $name->appendChild($text);
      $given = $doc->createElement('given');
        $text = $doc->createTextNode("\u$first_name");
      $given->appendChild($text);
    $name->appendChild($given);
  $person->appendChild($name);
    $text = $doc->createTextNode("\n    ");
  $person->appendChild($text);
    $email = $doc->createElement('email');
      $text = $doc->createTextNode("$first_name\@foo.com");
    $email->appendChild($text);
  $person->appendChild($email);
    $text = $doc->createTextNode("\n    ");
  $person->appendChild($text);
    $link = $doc->createElement('link');
    $link->setAttribute('manager','Big.Boss');
  $person->appendChild($link);
    $text = $doc->createTextNode("\n  ");
  $person->appendChild($text);

  return $person;
}

sub warning {
  print STDERR "WARNING:\n";
  print STDERR "LINE:    ", $_[0]->getLineNumber, "\n";
  print STDERR "COLUMN:  ", $_[0]->getColumnNumber, "\n";
  print STDERR "MESSAGE: ", $_[0]->getMessage, "\n";
  exit 1;
}

sub error {
  print STDERR "ERROR:\n";
  print STDERR "LINE:    ", $_[0]->getLineNumber, "\n";
  print STDERR "COLUMN:  ", $_[0]->getColumnNumber, "\n";
  print STDERR "MESSAGE: ", $_[0]->getMessage, "\n";
  exit 1;
}

sub fatal_error {
  print STDERR "FATAL ERROR:\n";
  print STDERR "LINE:    ", $_[0]->getLineNumber, "\n";
  print STDERR "COLUMN:  ", $_[0]->getColumnNumber, "\n";
  print STDERR "MESSAGE: ", $_[0]->getMessage, "\n";
  exit 1;
}

TERMINUS
close TESTSCRIPT;

@includes = map { "-I$_" } @INC;
$" = ' ';
system("perl @includes testscript.pl");
unlink 'testscript.pl';

exit 0;

