
#
# THE @#^%@#$ Test::Harness SETS ALL SORTS OF ANAL-RETENTIVE FLAGS THAT MAKE IT IMPOSSIBLE
# FOR THE TESTS TO PASS BECAUSE SWIG-GENERATED Xerces.pm MODULE ALWAYS HAS ERROR
# "Use of uninitialized value during global destruction."
# THUS, I HAD TO WORK AROUND IT.
#
open TESTSCRIPT, ">testscript.pl";
print TESTSCRIPT <<\TERMINUS;
use Xerces;

sub warning;
sub error;
sub fatal_error;

$| = 1;

# PRINT HOW MANY TEST THERE ARE
print "1..2\n";

$document = <<\END;
<?xml version="1.0" encoding="iso-8859-1" standalone="no"?>

<!DOCTYPE personnel SYSTEM "personal.dtd">
<!-- @version: -->
<personnel>

  <person id="Big.Boss">
    <name><family>Boss</family> <given>Big</given></name>
    <email>chief@foo.com</email>
    <link subordinates="one.worker two.worker three.worker four.worker five.worker"/>
  </person>

  <person id="one.worker">
    <name><family>Worker</family> <given>One</given></name>
    <email>one@foo.com</email>
    <link manager="Big.Boss"/>
  </person>

  <foo id="two.worker">
    <name><family>Worker</family> <given>Two</given></name>
    <email>two@foo.com</email>
    <link manager="Big.Boss"/>
  </person>

  <person id="three.worker">
    <name><family>Worker</family> <given>Three</given></name>
    <email>three@foo.com</email>
    <link manager="Big.Boss"/>
  </person>

  <person id="four.worker">
    <name><family>Worker</family> <given>Four</given></name>
    <email>four@foo.com</email>
    <link manager="Big.Boss"/>
  </person>

  <person id="five.worker">
    <name><family>Worker</family> <given>Five</given></name>
    <email>five@foo.com</email>
    <link manager="Big.Boss"/>
  </person>

</personnel>
END

{
  $error = "";

  my $dom = new DOMParser;

  my $error_handler = new perlErrorHandler;
  $error_handler->setWarningFunction(\&warning);
  $error_handler->setErrorFunction(\&error);
  $error_handler->setFatalErrorFunction(\&fatal_error);
  $dom->setErrorHandler($error_handler);

  eval {
    $dom->parse( new MemoryInputSource($document) );
  };

  print "not " if $error ne <<\END;
FATAL ERROR:
LINE:    23
COLUMN:  11
MESSAGE: Expected end of tag 'foo'
END
  print "ok\n";

}

{
  $error = "";

  my $dom = new DOMParser;

$error_handler = new perlErrorHandler;
$error_handler->setWarningFunction(\&warning);
$error_handler->setErrorFunction(\&error);
$error_handler->setFatalErrorFunction(\&fatal_error);
$dom->setErrorHandler($error_handler);

  $dom->setDoValidation(1);
  eval {
    $dom->parse( new MemoryInputSource($document) );
  };

  print "not " if $error ne <<\END;
ERROR:
LINE:    19
COLUMN:  7
MESSAGE: Unknown element 'foo'
END
  print "ok\n";
}

sub warning {
  $error = "WARNING:\nLINE:    " . $_[0]->getLineNumber . "\nCOLUMN:  " . $_[0]->getColumnNumber . "\nMESSAGE: " . $_[0]->getMessage . "\n";
  die "\n";
}

sub error {
  $error = "ERROR:\nLINE:    " . $_[0]->getLineNumber . "\nCOLUMN:  " . $_[0]->getColumnNumber . "\nMESSAGE: " . $_[0]->getMessage . "\n";
  die "\n";
}

sub fatal_error {
  $error = "FATAL ERROR:\nLINE:    " . $_[0]->getLineNumber . "\nCOLUMN:  " . $_[0]->getColumnNumber . "\nMESSAGE: " . $_[0]->getMessage . "\n";
  die "\n";
}
TERMINUS
close TESTSCRIPT;

@includes = map { "-I$_" } @INC;
$" = ' ';
system("perl @includes testscript.pl");
unlink 'testscript.pl';

exit 0;

